<?php
/**
 * YouTubeGallery Joomla! 1.5 Native Component
 * @version 1.0.2
 * @author DesignCompass Corp <admin@designcompasscorp.com>
 * @link http://www.designcompasscorp.com
 * @license GNU/GPL
 **/

defined('_JEXEC') or die('Restricted access');


$mainframe->registerEvent('onPrepareContent', 'plgContentYouTubeGallery');


function plgContentYouTubeGallery(&$row, &$params, $page=0)
{
	if (is_object($row)) {
		return plgYouTubeGallery($row->text, $params);
	}
	return plgYouTubeGallery($row, $params);
}

///////////////////

function plgYouTubeGallery(&$text, &$params)
{
	
	$yg=new YouTubeGalleryClass;
	
	$options=array();
	$fList=$yg->getListToReplace('youtubegallery',$options,$text);
	
	for($i=0; $i<count($fList);$i++)
	{
		$replaceWith=$yg->getYouTubeGallery($options[$i],$i);
		
		$text=str_replace($fList[$i],$replaceWith,$text);	
	}
	
	
	return true;
}


class YouTubeGalleryClass
{
	
	
	function getListToReplace($par,&$options,&$text)
	{
		$fList=array();
		$l=strlen($par)+2;
	
		$offset=0;
		do{
			if($offset>=strlen($text))
				break;
		
			$ps=strpos($text, '{'.$par.'=', $offset);
			if($ps===false)
				break;
		
		
			if($ps+$l>=strlen($text))
				break;
		
		$pe=strpos($text, '}', $ps+$l);
				
		if($pe===false)
			break;
		
		$notestr=substr($text,$ps,$pe-$ps+1);

			$options[]=substr($text,$ps+$l,$pe-$ps-$l);
			$fList[]=$notestr;
			

		$offset=$ps+$l;
		
			
		}while(!($pe===false));
		
		return $fList;
	}

	function extractID($youtubeURL)
	{
				
				$arr=$this->parse_query($youtubeURL);
		        return $arr[v];
	}
	function parse_query($var)
		{
		 
		 $var  = parse_url($var);
		 $var  = html_entity_decode($var[query]);
		 $var  = explode('&', $var);
		 $arr  = array();

		 foreach($var as $val)
		  {
		   $x          = explode('=', $val);
		   $arr[$x[0]] = $x[1];
		  }
		 unset($val, $x, $var);
		 return $arr;
	}
		
	function getVideoTitle($videoid)
	{
				
		$url = "http://gdata.youtube.com/feeds/api/videos/". $videoid;
				

		$doc = new DOMDocument;
		$doc->load($url);
				
				
		return $doc->getElementsByTagName("title")->item(0)->nodeValue;
	}

	function getGalleryList($row,&$gallery_list,$playvideo,$showtitle)
	{
		
		$gallery_list=array();
		
		
				
		
			
						
			$a=explode("\n",$row->gallerylist);
						
			$firstvideo='';
						
			foreach($a as $b)
			{
				$videoid=$this->extractID(trim($b));
						
				if($videoid!='')
				{
					if($firstvideo=='')
						$firstvideo=$videoid;
										
					if($showtitle)
					{
						$theTitle=$this->getVideoTitle($videoid);
						$gallery_list[]=array(videoid=>$videoid, imageurl=>$this->getImageURL($videoid), title=>$theTitle);
					}
					else
						$gallery_list[]=array(videoid=>$videoid, imageurl=>$this->getImageURL($videoid));
										
					//$gallery_list[]=array(videoid=>$videoid, imageurl=>$this->getImageURL($videoid), title=>$this->getVideoTitle($videoid));
				}
			}
		
						
			if($playvideo==1 and !JRequest::getVar('videoid'))
			{
				JRequest::setVar('videoid',$firstvideo);
			}
		
	}
	function getImageURL($videoid)
	{
		       return 'http://img.youtube.com/vi/'.$videoid.'/default.jpg';
	}

	function getYouTubeGallery($galleryparams,$count)
	{
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_youtubegallery'.DS.'includes'.DS.'render.php');
	
		$opt=explode(',',$galleryparams);
		if(count($opt)<1)
			return '';
	

		$galleryid=(int)$opt[0];
		
		$db = & JFactory::getDBO();
				
		$query = 'SELECT * FROM #__youtubegallery WHERE id='.$galleryid.' LIMIT 1';
		
		//echo $query;
		//die;
		$db->setQuery($query);
				
		if (!$db->query())    echo ( $db->stderr());
		$rows = $db->loadObjectList();
				
		if(count($rows)==0)
			return '';
			
		$row=$rows[0];
		
		if(count($opt)>1)
		{
			$width=(int)$opt[1];
			$height=(int)$opt[2];
				
		
			$playvideo=(int)$opt[3];
			$repeat=(int)$opt[4];
			$fullscreen=(int)$opt[5];
			$autoplay=(int)$opt[6];
			$relatedvideos=(int)$opt[7];
			$showinfo=(int)$opt[8];
			$thumbbgcolor=$opt[9];
			$columns=(int)$opt[10];
			
			$showtitle=(int)$opt[11];
		}
		else
		{
			$width=$row->width;
			$height=$row->height;
			
			
			$playvideo=$row->playvideo;
			$repeat=$row->repeat;
			$fullscreen=$row->fullscreen;
			$autoplay=$row->autoplay;
			$relatedvideos=$row->related;
			$showinfo=$row->showinfo;
			$thumbbgcolor=$row->bgcolor;
			$columns=$row->cols;
			$showtitle=$row->showtitle;
		}
		
	
		if($width<1)
			$width=400;
			
		if($height<1)
				$height=300;
	
		$gallery_name=$row->galleryname;
	

		$gallery_list=array();
	
		
		$this->getGalleryList($row,$gallery_list,$playvideo,$showtitle);

		$renderer= new YouTubeGalleryRenderer;
		return $renderer->render($gallery_name,$gallery_list,$galleryid,$width,$height,$playvideo,$repeat,$fullscreen,$autoplay,$relatedvideos,$showinfo,$thumbbgcolor,$columns,$showtitle);
		
	
	
		
	}

	
}


?>